/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 * 
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2009 Sun Microsystems, Inc. All rights reserved.
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License. You can obtain
 * a copy of the License at https://glassfish.dev.java.net/public/CDDL+GPL.html
 * or glassfish/bootstrap/legal/LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 * 
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at glassfish/bootstrap/legal/LICENSE.txt.
 * Sun designates this particular file as subject to the "Classpath" exception
 * as provided by Sun in the GPL Version 2 section of the License file that
 * accompanied this code.  If applicable, add the following below the License
 * Header, with the fields enclosed by brackets [] replaced by your own
 * identifying information: "Portions Copyrighted [year]
 * [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */

package privilegedappclient;

import java.io.File;
import java.io.PrintWriter;

/**
 * Example app client requiring elevated privs to work.
 * Test for issue 7227.
 * <p>
 * Be sure to pass as the first argument to the client a file path to which
 * this app client will write "Success" if the client works correctly.
 *
 * @author tjquinn
 */
public class Main {

    private static final Thread.UncaughtExceptionHandler handler =
            new LastChanceHandler();

    private static final String LINE_SEP = System.getProperty("line.separator");
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        int result = 0;
        try {
            /*
             * The following statement will fail if the fix for 7227 does not
             * work or is lost.
             */
            //Thread.currentThread().setDefaultUncaughtExceptionHandler(
            //        new LastChanceHandler());
//            new LastChanceHandler();
            File f = new File(args[0]);
            if (f.exists()) {
                f.delete();
            }
            PrintWriter pw = new PrintWriter(f);
            System.err.println(
                    "***" + LINE_SEP +
                    "***" + LINE_SEP +
                    "     Success" + LINE_SEP +
                    "***" + LINE_SEP +
                    "***");
            pw.println("Success");
            pw.close();
        } catch (Throwable t) {
            t.printStackTrace();
        } finally {
            try {
                Thread.currentThread().sleep(3 * 1000);
            } catch (InterruptedException e) {
                e.printStackTrace();
                result = 1;
            }
            System.exit(result);
        }
    }
}
